Loading...
Searching...
No Matches
juce::LockingAsyncUpdater Class Referencefinal

## Detailed Description

A bit like an AsyncUpdater, but guarantees that after cancelPendingUpdate() returns, the async function will never be called until triggerAsyncUpdate() is called again.

This is an important guarantee for writing classes with async behaviour that can still be destroyed safely from a background thread.

Note that all of the member functions of this type have a chance of blocking, so this class is unsuitable for broadcasting changes from a realtime thread.

The documentation for this class was generated from the following file:

- juce_events/broadcasters/juce_LockingAsyncUpdater.h

## Public Member Functions

| LockingAsyncUpdater (std::function< void()> callbackToUse)
| Creates a LockingAsyncUpdater object that will call the provided callback on the main thread when triggered.
| LockingAsyncUpdater (LockingAsyncUpdater &&other) noexcept
| Move constructor.
LockingAsyncUpdater & | operator= (LockingAsyncUpdater &&other) noexcept
| Move assignment operator.
| ~LockingAsyncUpdater ()
| Destructor.
void | triggerAsyncUpdate ()
| Causes the callback to be triggered at a later time.
void | cancelPendingUpdate () noexcept
| This will stop any pending updates from happening.
void | handleUpdateNowIfNeeded ()
| If an update has been triggered and is pending, this will invoke it synchronously.
bool | isUpdatePending () const noexcept
| Returns true if there's an update callback in the pipeline.

## Constructors and Destructors

## LockingAsyncUpdater() [1/2]

juce::LockingAsyncUpdater::LockingAsyncUpdater | ( | std::function< void()> | callbackToUse | ) |

explicit

Creates a LockingAsyncUpdater object that will call the provided callback on the main thread when triggered.

Note that the LockingAsyncUpdater takes an internal mutex before calling the provided callback. Therefore, in order to avoid deadlocks, you should (ideally) ensure that no locks are taken inside the callbackToUse. If you do need to take a lock inside the callback, make sure that you do not hold the same lock while calling any of the LockingAsyncUpdater member functions.

Referenced by isUpdatePending(), LockingAsyncUpdater(), and operator=().

## LockingAsyncUpdater() [2/2]

juce::LockingAsyncUpdater::LockingAsyncUpdater | ( | LockingAsyncUpdater && | other | ) |

noexcept

Move constructor.

References LockingAsyncUpdater().

## ~LockingAsyncUpdater()

juce::LockingAsyncUpdater::~LockingAsyncUpdater | ( |  | ) |

Destructor.

If there are any pending callbacks when the object is deleted, these are lost. The async callback is guaranteed not to be called again once the destructor has completed.

## Member Functions

## operator=()

LockingAsyncUpdater & juce::LockingAsyncUpdater::operator= | ( | LockingAsyncUpdater && | other | ) |

noexcept

Move assignment operator.

References LockingAsyncUpdater().

## triggerAsyncUpdate()

void juce::LockingAsyncUpdater::triggerAsyncUpdate | ( |  | ) |

Causes the callback to be triggered at a later time.

This method returns quickly, after which a callback to the handleAsyncUpdate() method will be made by the impl thread as soon as possible.

If an update callback is already pending but hasn't started yet, calling this method will have no effect.

It's thread-safe to call this method from any thread, BUT beware of calling it from a real-time (e.g. audio) thread, because it unconditionally locks a mutex. This may block, e.g. if this is called from a background thread while the async callback is in progress on the main thread.

## cancelPendingUpdate()

void juce::LockingAsyncUpdater::cancelPendingUpdate | ( |  | ) |

noexcept

This will stop any pending updates from happening.

If a callback is already in progress on another thread, this will block until the callback has finished before returning.

## handleUpdateNowIfNeeded()

void juce::LockingAsyncUpdater::handleUpdateNowIfNeeded | ( |  | ) |

If an update has been triggered and is pending, this will invoke it synchronously.

Use this as a kind of "flush" operation - if an update is pending, the handleAsyncUpdate() method will be called immediately; if no update is pending, then nothing will be done.

Because this may invoke the callback, this method must only be called on the main event thread.

References handleUpdateNowIfNeeded().

Referenced by handleUpdateNowIfNeeded().

## isUpdatePending()

bool juce::LockingAsyncUpdater::isUpdatePending | ( |  | ) | const

noexcept

Returns true if there's an update callback in the pipeline.

References isUpdatePending(), JUCE_DECLARE_NON_COPYABLE_WITH_LEAK_DETECTOR, and LockingAsyncUpdater().

Referenced by isUpdatePending().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited